Bug 737308 - Review Request: gdlmm - C++ bindings for the gdl library
Summary: Review Request: gdlmm - C++ bindings for the gdl library
Keywords:
Status: CLOSED NEXTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Dodji Seketeli
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2011-09-10 23:06 UTC by Kalev Lember
Modified: 2011-09-19 10:34 UTC (History)
4 users (show)

Fixed In Version: gdlmm-3.1.90-1.fc16
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2011-09-19 10:34:49 UTC
dodji: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Kalev Lember 2011-09-10 23:06:33 UTC
Spec URL: http://kalev.fedorapeople.org/gdlmm.spec
SRPM URL: http://kalev.fedorapeople.org/gdlmm-3.1.90-1.fc16.src.rpm
Description:
This package contains C++ bindings for the GNOME Development/Docking (gdl)
library.

Comment 1 Dodji Seketeli 2011-09-18 18:46:18 UTC
I have reviewed this package, successfully built it[1], installed it,
built the Nemiver debugger against it, and could see test the package
by using Nemiver.

This package is OK to get into F17, as far as I can tell.

Please find below the formal review.

* rpmlint outputs

$ rpmlint SRPMS/gdlmm-3.1.90-1.fc16.src.rpm  -i RPMS/x86_64/gdlmm-3.1.90-1.fc15.x86_64.rpm RPMS/x86_64/gdlmm-devel-3.1.90-1.fc15.x86_64.rpm RPMS/noarch/gdlmm-doc-3.1.90-1.fc15.noarch.rpm gdlmm gdlmm-devel
(none): E: no installed packages by name SRPMS/gdlmm-3.1.90-1.fc16.src.rpm
(none): E: no installed packages by name -i
(none): E: no installed packages by name RPMS/x86_64/gdlmm-3.1.90-1.fc15.x86_64.rpm
(none): E: no installed packages by name RPMS/x86_64/gdlmm-devel-3.1.90-1.fc15.x86_64.rpm
(none): E: no installed packages by name RPMS/noarch/gdlmm-doc-3.1.90-1.fc15.noarch.rpm
gdlmm.x86_64: W: spelling-error Summary(en_US) gdl -> gel, gal, godly
gdlmm.x86_64: W: spelling-error %description -l en_US gdl -> gel, gal, godly
gdlmm.x86_64: W: unstripped-binary-or-object /usr/lib64/libgdlmm-3.0.so.0.0.0
gdlmm.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libgdlmm-3.0.so.0.0.0 /usr/lib64/libgdkmm-3.0.so.1
gdlmm.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libgdlmm-3.0.so.0.0.0 /usr/lib64/libgiomm-2.4.so.1
gdlmm.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libgdlmm-3.0.so.0.0.0 /usr/lib64/libpangomm-1.4.so.1
gdlmm.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libgdlmm-3.0.so.0.0.0 /usr/lib64/libcairomm-1.0.so.1
gdlmm.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libgdlmm-3.0.so.0.0.0 /usr/lib64/libgdk-3.so.0
gdlmm.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libgdlmm-3.0.so.0.0.0 /usr/lib64/libatk-1.0.so.0
gdlmm.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libgdlmm-3.0.so.0.0.0 /lib64/libgio-2.0.so.0
gdlmm.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libgdlmm-3.0.so.0.0.0 /usr/lib64/libpangoft2-1.0.so.0
gdlmm.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libgdlmm-3.0.so.0.0.0 /usr/lib64/libpangocairo-1.0.so.0
gdlmm.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libgdlmm-3.0.so.0.0.0 /usr/lib64/libgdk_pixbuf-2.0.so.0
gdlmm.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libgdlmm-3.0.so.0.0.0 /usr/lib64/libpng12.so.0
gdlmm.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libgdlmm-3.0.so.0.0.0 /usr/lib64/libcairo-gobject.so.2
gdlmm.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libgdlmm-3.0.so.0.0.0 /usr/lib64/libpango-1.0.so.0
gdlmm.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libgdlmm-3.0.so.0.0.0 /usr/lib64/libfreetype.so.6
gdlmm.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libgdlmm-3.0.so.0.0.0 /usr/lib64/libfontconfig.so.1
gdlmm.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libgdlmm-3.0.so.0.0.0 /lib64/libgmodule-2.0.so.0
gdlmm.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libgdlmm-3.0.so.0.0.0 /usr/lib64/libcairo.so.2
gdlmm.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libgdlmm-3.0.so.0.0.0 /lib64/libgthread-2.0.so.0
gdlmm.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libgdlmm-3.0.so.0.0.0 /lib64/librt.so.1
gdlmm.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libgdlmm-3.0.so.0.0.0 /lib64/libm.so.6
gdlmm-devel.x86_64: W: no-documentation
2 packages and 0 specfiles checked; 0 errors, 24 warnings.
$ 

The only warning I'd care about are the unused-direct-shlib-dependency
one.  I believe this is because the gdlmm upstream tarball lacks
-Wl,-as-needed linker option.  This is not an error.  It'll merely
cause a slower-to-load library.  My recommendation would be to report
this upstream, but I wouldn't block this package because of that.

* MUST items
- [X] rpmlint must be run on the source rpm and all binary rpms the
      build produces. The output should be posted in the review.
- [X] The package must be named according to the Package Naming
      Guidelines .
- [X] The spec file name must match the base package %{name}, in the
      format %{name}.spec unless your package has an exemption.
- [X] The package must meet the Packaging Guidelines .
- [X] The package must be licensed with a Fedora approved license and
      meet the Licensing Guidelines .
- [X] The License field in the package spec file must match the actual
      license.
- [X] If (and only if) the source package includes the text of the
      license(s) in its own file, then that file, containing the text of the
      license(s) for the package must be included in %doc.
- [X] The spec file must be written in American English
- [X] The spec file for the package MUST be legible.
- [X] The sources used to build the package must match the upstream
      source, as provided in the spec URL. Reviewers should use md5sum for
      this task. If no upstream URL can be specified for this package,
      please see the Source URL Guidelines for how to deal with this.
- [X] The package MUST successfully compile and build into binary rpms
      on at least one primary architecture.
- [X] If the package does not successfully compile, build or work on
      an architecture, then those architectures should be listed in the spec
      in ExcludeArch. Each architecture listed in ExcludeArch MUST have a
      bug filed in bugzilla, describing the reason that the package does not
      compile/build/work on that architecture. The bug number MUST be placed
      in a comment, next to the corresponding ExcludeArch line.
- [X] All build dependencies must be listed in BuildRequires, except
      for any that are listed in the exceptions section of the Packaging
      Guidelines ; inclusion of those as BuildRequires is optional. Apply
      common sense.
- [X] The spec file MUST handle locales properly. This is done by
      using the %find_lang macro. Using %{_datadir}/locale/* is strictly
      forbidden.
- [X] Every binary RPM package (or subpackage) which stores shared
      library files (not just symlinks) in any of the dynamic linker's
      default paths, must call ldconfig in %post and %postun.
- [X] Packages must NOT bundle copies of system libraries.
- [X] If the package is designed to be relocatable, the packager must
      state this fact in the request for review, along with the
      rationalization for relocation of that specific package. Without this,
      use of Prefix: /usr is considered a blocker.
- [X] A package must own all directories that it creates. If it does
      not create a directory that it uses, then it should require a package
      which does create that directory.
- [X] A Fedora package must not list a file more than once in the spec
      file's %files listings. (Notable exception: license texts in specific
      situations)
- [X] Permissions on files must be set properly. Executables should be
      set with executable permissions, for example.
- [X] Each package must consistently use macros.
- [X] The package must contain code, or permissable content.
- [X] Large documentation files must go in a -doc subpackage. (The
      definition of large is left up to the packager's best judgement, but
      is not restricted to size. Large can refer to either size or
      quantity).
- [X] If a package includes something as %doc, it must not affect the
      runtime of the application. To summarize: If it is in %doc, the
      program must run properly if it is not present.
- [X] Header files must be in a -devel package.
- [X] Static libraries must be in a -static package.
- [X] If a package contains library files with a suffix
      (e.g. libfoo.so.1.1), then library files that end in .so (without
      suffix) must go in a -devel package.
- [X] In the vast majority of cases, devel packages must require the
      base package using a fully versioned dependency: Requires:
      %{name}%{?_isa} = %{version}-%{release}
- [X] Packages must NOT contain any .la libtool archives, these must
      be removed in the spec if they are built.
- [X] Packages containing GUI applications must include a
      %{name}.desktop file, and that file must be properly installed with
      desktop-file-install in the %install section. If you feel that your
      packaged GUI application does not need a .desktop file, you must put a
      comment in the spec file with your explanation.
- [X] Packages must not own files or directories already owned by
      other packages. The rule of thumb here is that the first package to be
      installed should own the files or directories that other packages may
      rely upon. This means, for example, that no package in Fedora should
      ever share ownership with any of the files or directories owned by the
      filesystem or man package. If you feel that you have a good reason to
      own a file or directory that another package owns, then please present
      that at package review time.
- [X] All filenames in rpm packages must be valid UTF-8.

* SHOULD Items

- [X] If the source package does not include license text(s) as
      a separate file from upstream, the packager SHOULD query upstream
      to include it.
- [X] The description and summary sections in the package spec
      file should contain translations for supported Non-English
      languages, if available.
- [X] The reviewer should test that the package builds in
      mock.
- [X] The package should compile and build into binary rpms on
      all supported architectures.
- [X] The reviewer should test that the package functions as
      described. A package should not segfault instead of running, for
      example.
- [X] If scriptlets are used, those scriptlets must be
      sane. This is vague, and left up to the reviewers judgement to
      determine sanity.
- [X] Usually, subpackages other than devel should require the
      base package using a fully versioned dependency.
- [X] The placement of pkgconfig(.pc) files depends on their
      usecase, and this is usually for development purposes, so should
      be placed in a -devel pkg. A reasonable exception is that the main
      pkg itself is a devel tool not installed in a user runtime,
      e.g. gcc or gdb.
- [X] If the package has file dependencies outside of /etc,
      /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package
      which provides the file instead of the file itself.
- [X] your package should contain man pages for
      binaries/scripts. If it doesn't, work with upstream to add them
      where they make sense.

[1]: http://koji.fedoraproject.org/koji/taskinfo?taskID=3358993

Comment 2 Kalev Lember 2011-09-19 07:36:47 UTC
Thanks for the review, Dodji!

(In reply to comment #1)
> The only warning I'd care about are the unused-direct-shlib-dependency
> one.  I believe this is because the gdlmm upstream tarball lacks
> -Wl,-as-needed linker option.  This is not an error.  It'll merely
> cause a slower-to-load library.  My recommendation would be to report
> this upstream, but I wouldn't block this package because of that.

I'm not really sure this is something that each individual GNOME module
should have to handle. Perhaps the flag should come from distro-wide LDFLAGS
instead. I know Mandriva has been doing this for a while:
http://wiki.mandriva.com/en/Overlinking#--as-needed

Some Fedora packages have amazing hacks to get -Wl,-as-needed passed to
the linker, for example gtk3 is doing this by patching the libtool script
with sed:
http://pkgs.fedoraproject.org/gitweb/?p=gtk3.git;a=blob;f=gtk3.spec;h=835a21a64ce1bf2d59baeaf5e1e58ada4f50a20d;hb=HEAD#l130

Comment 3 Kalev Lember 2011-09-19 07:39:53 UTC
New Package SCM Request
=======================
Package Name: gdlmm
Short Description: C++ bindings for the gdl library
Owners: kalev dodji
Branches: f16
InitialCC:

Comment 4 Gwyn Ciesla 2011-09-19 10:08:43 UTC
Git done (by process-git-requests).

Comment 5 Kalev Lember 2011-09-19 10:34:49 UTC
Package imported and built; closing the ticket.


Note You need to log in before you can comment on or make changes to this bug.